unit dll_dde_function;

interface
uses
  SysUtils,
  Ddeman,
  Windows,
  Classes,
  dnako_import,
  dnako_import_types,
  dll_plugin_helper
;
type
  TNakoDdeSarverConv= Class(TDdeServerConv)
  private
    procedure setEvent;
    procedure DdeDoOpen(Sender: TObject);
    procedure DdeDoClose(Sender: TObject);
    procedure DdeDoReceiveMacro(Sender: TObject; Msg: TStrings);
    procedure DoEvent(EventName: string);
  public
    InstanceVar: PHiValue;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;

  TDdeList=class(TList)
    destructor Destroy; override;
  end;

function dde_create(HandleArg: DWORD): PHiValue; stdcall;
function dde_settopic(HandleArg: DWORD): PHiValue; stdcall;
function dde_gettopic(HandleArg: DWORD): PHiValue; stdcall;
function dde_send(HandleArg: DWORD): PHiValue; stdcall;
function dde_datasend(HandleArg: DWORD): PHiValue; stdcall;

implementation
var
  DdeList:TDdeList;

  { TDdeList }
  destructor TDdeList.Destroy;
  var
    i:integer;
  begin
    if Count<>0 then begin
      for i:=0 to Count -1 do
        TDdeServerConv(Items[i]).Free;
    end;
    inherited
  end;

  { TNakoDdeSarverConv }

  constructor TNakoDdeSarverConv.Create(AOwner: TComponent);
  begin
    inherited;
    setEvent;
  end;

  destructor TNakoDdeSarverConv.Destroy;
  begin
    inherited
  end;

  procedure TNakoDdeSarverConv.setEvent;
  begin
    self.OnOpen         :=DdeDoOpen;
    self.OnClose        :=DdeDoClose;
    self.OnExecuteMacro :=DdeDoReceiveMacro;
  end;
  procedure TNakoDdeSarverConv.DdeDoOpen(Sender: TObject);
  begin
    DoEvent('ڑ');
  end;

  procedure TNakoDdeSarverConv.DdeDoClose(Sender: TObject);
  begin
    DoEvent('ؒf');
  end;

  procedure TNakoDdeSarverConv.DdeDoReceiveMacro(Sender: TObject; Msg: TStrings);
  var
    p:PHiValue;
  begin
    p := nako_group_findMember(InstanceVar, 'Mf[^');
    if p <> nil then hi_setStr(p, Msg.text);

    DoEvent('M');
  end;

  procedure TNakoDdeSarverConv.DoEvent(EventName: string);
  var
    p:PHiValue;
  begin
    p := nako_group_findMember(InstanceVar, PChar(EventName));
    if p = nil then Exit;
    nako_group_exec(InstanceVar, PChar(EventName));
  end;

  { exprots }

  function dde_create(HandleArg: DWORD): PHiValue; stdcall;
  var
    p:TNakoDdeSarverConv;
  begin
    p := TNakoDdeSarverConv.Create(nil);
    p.Name:=hi_str(nako_getFuncArg(HandleArg,1));
    p.InstanceVar :=nako_getFuncArg(HandleArg,0);
    DdeList.Add(p);
    Result := hi_newInt(Integer(p));
  end;

  function dde_settopic(HandleArg: DWORD): PHiValue; stdcall;
  var
    obj:PHiValue;
    p:TNakoDdeSarverConv;
  begin
    obj := nako_group_findMember(nako_getFuncArg(HandleArg,0), 'IuWFNg');
    if obj = nil then raise Exception.Create('IuWFNgł܂B');
    p := TNakoDdeSarverConv(Integer(hi_int(obj)));
    p.Name:=hi_str(nako_getFuncArg(HandleArg,1));
    result:=nil;
  end;

  function dde_gettopic(HandleArg: DWORD): PHiValue; stdcall;
  var
    obj:PHiValue;
    p:TNakoDdeSarverConv;
  begin
    obj := nako_group_findMember(nako_getFuncArg(HandleArg,0), 'IuWFNg');
    if obj = nil then raise Exception.Create('IuWFNgł܂B');
    p := TNakoDdeSarverConv(Integer(hi_int(obj)));
    Result:= hi_newStr(p.Name);
  end;

  function dde_send(HandleArg: DWORD): PHiValue; stdcall;
  var
    DDE: TDdeClientConv;
  begin
    Result:=nil;
    DDE := TDdeClientConv.Create(nil);
    DDE.ConnectMode:=ddeAutomatic;
    try
      if DDE.SetLink( hi_str(nako_getFuncArg(HandleArg,0)),hi_str(nako_getFuncArg(HandleArg,1))) then begin
        DDE.ExecuteMacro(Pchar(hi_str(nako_getFuncArg(HandleArg,2))),true);
      end else
        raise Exception.Create('DDET[o[ւ̐ڑ^CAEg܂B');
    finally
      DDE.CloseLink;
      DDE.Free;
    end;
  end;

  function dde_datasend(HandleArg: DWORD): PHiValue; stdcall;
  var
    DDE: TDdeClientConv;
    res:PChar;
  begin
    Result:=hi_newStr('');
    res:=nil;
    DDE := TDdeClientConv.Create(nil);
    DDE.ConnectMode:=ddeAutomatic;
    try
      if DDE.SetLink( hi_str(nako_getFuncArg(HandleArg,0)),hi_str(nako_getFuncArg(HandleArg,1))) then begin
        res:=DDE.RequestData(hi_str(nako_getFuncArg(HandleArg,2)));
      end else
        raise Exception.Create('DDET[o[ւ̐ڑ^CAEg܂B');
    finally
      hi_setStr(Result,res);
      StrDispose(res);
      DDE.CloseLink;
      DDE.Free;
    end;
  end;
initialization
begin
  DdeList:=TDdelist.Create;
end;
finalization
begin
  DdeList.Free;
end;
end.
